Skip to main content
Original408 words2 min

题解:P9408 『STA - R2』Locked

Summary

每位是 0 到 9 循环表盘的序列,把某位从 x 拨到 y 的次数取 x 减 y 与 y 减 x 对 10 取模的较小值,要把序列改成先不减后不增的单峰形态,求最小总拨动次数。设 g 为前 i 位单调不减且以 j 结尾的最小次数、h 为后 i 位单调不减且以 j 开头的最小次数,正反两遍 DP 求出,再枚举峰顶 i 与峰值 j,减去被重复计入的一次,取 g 加 h 再减该次的最小值。时间复杂度 O(n)。

解题思路​

设 f(x,y)f(x,y) 表示将 xx 变成 yy 的最小拨动次数,不难得出:

f(x,y)=min⁡((x−y) mod 10,(y−x) mod 10)f(x,y)=\min((x-y)\bmod 10,(y-x)\bmod 10)

考虑使用 DP 解决:设 gi,jg_{i,j} 表示前 ii 个位置单调不减且以 jj 结尾的序列最小拨动次数。

显然前一项不能比后一项大,所以后一项只能由小于等于前一项的结果中取最小值:

gi,j=min⁡k=1jgi−1,k+f(ai,j)g_{i,j}=\min_{k=1}^j g_{i-1,k}+f(a_i,j)

同理,设 hi,jh_{i,j} 表示后 ii 个位置单调不减且以 jj 开头的序列最小拨动次数:

hi,j=min⁡k=1jhi+1,k+f(ai,j)h_{i,j}=\min_{k=1}^j h_{i+1,k}+f(a_i,j)

枚举所有的 i,ji,j,表示以 ii 为峰顶,以 jj 为峰值的拨动次数,峰顶会被重复计算 11 次,所以要减去 f(ai,j)f(a_i,j) 再取最小值,答案为:

min⁡i=1nmin⁡j=09gi,j+hi,j−f(ai,j)\min_{i=1}^n\min_{j=0}^9 g_{i,j}+h_{i,j}-f(a_i,j)

参考代码​

926 Bcpp
#include <bits/stdc++.h>
using namespace std;

const int inf=0x3f3f3f3f;
const int N=5000005;
int a[N],g[N][10],h[N][10];
int f(int x,int y)
{
return min((x-y+10)%10,(y-x+10)%10);
}
int main()
{
ios::sync_with_stdio(false);
cin.tie(nullptr);
int n;
cin>>n;
for(int i=1;i<=n;i++)
{
cin>>a[i];
}
for(int i=1;i<=n;i++)
{
for(int j=0;j<10;j++)
{
g[i][j]=h[i][j]=inf;
}
}
for(int i=1;i<=n;i++)
{
for(int j=0;j<10;j++)
{
for(int k=0;k<=j;k++)
{
g[i][j]=min(g[i][j],g[i-1][k]+min(abs((a[i]-j+10)%10),abs((j-a[i]+10)%10)));
}
}
}
for(int i=n;i>=1;i--)
{
for(int j=0;j<10;j++)
{
for(int k=0;k<=j;k++)
{
h[i][j]=min(h[i][j],h[i+1][k]+min(abs((a[i]-j+10)%10),abs((j-a[i]+10)%10)));
}
}
}
int ans=inf;
for(int i=1;i<=n;i++)
{
for(int j=0;j<10;j++)
{
ans=min(ans,g[i][j]+h[i][j]-min(abs((a[i]-j+10)%10),abs((j-a[i]+10)%10)));
}
}
cout<<ans<<'\n';
return 0;
}